<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/before_journal_manager_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/15/85  before_journal_manager_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The before_journal_manager_ subroutine provides the means to
<span id="L5" class="LineNr">  5 </span>manipulate, and obtain information about, before journals.  Before
<span id="L6" class="LineNr">  6 </span>journals are used to store before images of protected data management
<span id="L7" class="LineNr">  7 </span><span class="textRainbow_lv0_p0">(</span>DM<span class="textRainbow_lv0_p0">)</span> files, for the purpose of rolling back modifications to these
<span id="L8" class="LineNr">  8 </span>files in the event of failure.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>Entry points in before_journal_manager_:
<span id="L12" class="LineNr"> 12 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>:Entry:  close_bj:  03/15/85 before_journal_manager_$close_bj
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>Function:  This entry point closes the specified before journal, making
<span id="L19" class="LineNr"> 19 </span>it unavailable to the current process.  A journal can be opened more
<span id="L20" class="LineNr"> 20 </span>than once in a process, in which case the same opening id is returned
<span id="L21" class="LineNr"> 21 </span>for each open request.  In that case, the close operation merely
<span id="L22" class="LineNr"> 22 </span>decreases by one the number of journal openings in the process.  If a
<span id="L23" class="LineNr"> 23 </span>close_bj request is issued by a process on a journal while the process
<span id="L24" class="LineNr"> 24 </span>still has an active transaction in that journal, the journal cannot be
<span id="L25" class="LineNr"> 25 </span>closed and an error code is returned to the caller.  If the journal to
<span id="L26" class="LineNr"> 26 </span>be closed was the default before journal for the process, the before
<span id="L27" class="LineNr"> 27 </span>journal which was last opened in the process <span class="textRainbow_lv0_p0">(</span>if any<span class="textRainbow_lv0_p0">)</span> becomes the
<span id="L28" class="LineNr"> 28 </span>default before journal <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; under the set_default_bj entry<span class="textRainbow_lv0_p0">)</span>.
<span id="L29" class="LineNr"> 29 </span>
<span id="L30" class="LineNr"> 30 </span>
<span id="L31" class="LineNr"> 31 </span>Syntax:
<span id="L32" class="LineNr"> 32 </span>declare before_journal_manager_$close_bj entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L33" class="LineNr"> 33 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L34" class="LineNr"> 34 </span>call before_journal_manager_$close_bj <span class="textRainbow_lv0_p0">(</span>bj_opening_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>Arguments:
<span id="L38" class="LineNr"> 38 </span>bj_opening_id
<span id="L39" class="LineNr"> 39 </span>   is the opening identifier of the before journal.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr"> 40 </span>code
<span id="L41" class="LineNr"> 41 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>:Entry:  create_bj:  03/15/85 before_journal_manager_$create_bj
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>Function:  This entry point creates a before journal file as specified
<span id="L48" class="LineNr"> 48 </span>by the input arguments.
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>Syntax:
<span id="L52" class="LineNr"> 52 </span>declare before_journal_manager_$create_bj entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L53" class="LineNr"> 53 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L54" class="LineNr"> 54 </span>call before_journal_manager_$create_bj <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span>
<span id="L55" class="LineNr"> 55 </span>     n_control_intervals<span class="textRainbow_lv0_o0">,</span> control_interval_size<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>Arguments:
<span id="L59" class="LineNr"> 59 </span>dir_name
<span id="L60" class="LineNr"> 60 </span>   is the pathname of the directory in which the before journal is to
<span id="L61" class="LineNr"> 61 </span>   be created.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L62" class="LineNr"> 62 </span>entry_name
<span id="L63" class="LineNr"> 63 </span>   is the entry name of the before journal to be created.  The .bj
<span id="L64" class="LineNr"> 64 </span>   suffix must be included.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L65" class="LineNr"> 65 </span>n_control_intervals
<span id="L66" class="LineNr"> 66 </span>   is the size of the journal expressed in the number of control
<span id="L67" class="LineNr"> 67 </span>   intervals.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> A before journal is a circular file; when
<span id="L68" class="LineNr"> 68 </span>   information is no longer useful <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span> before images for committed
<span id="L69" class="LineNr"> 69 </span>   or aborted transactions<span class="textRainbow_lv0_p0">)</span>, it will be overwritten, allowing the space
<span id="L70" class="LineNr"> 70 </span>   to be reused.  In estimating the size of a journal, you should
<span id="L71" class="LineNr"> 71 </span>   consider the number of transactions to be using the journal
<span id="L72" class="LineNr"> 72 </span>   simultaneously, as well as their profiles, i.e., their length in
<span id="L73" class="LineNr"> 73 </span>   time and the rate at which they modify data, to optimize
<span id="L74" class="LineNr"> 74 </span>   performance.
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>control_interval_size
<span id="L78" class="LineNr"> 78 </span>   is the size of the before journal control interval in number of
<span id="L79" class="LineNr"> 79 </span>   bytes.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The size is currently fixed at 4096.
<span id="L80" class="LineNr"> 80 </span>code
<span id="L81" class="LineNr"> 81 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>:Entry: get_bj_path_from_oid: 03/15/85 before_journal_manager_$get_bj_path_from_oid
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>Function:  This entry point returns the directory pathname and the
<span id="L88" class="LineNr"> 88 </span>entry name of the specified before journal.  For this operation to be
<span id="L89" class="LineNr"> 89 </span>successful, the before journal must be open in the current process.
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>If a zero code is returned, the operation is successful and the
<span id="L92" class="LineNr"> 92 </span>dir_name and entry_name arguments are set to the proper values.  If a
<span id="L93" class="LineNr"> 93 </span>nonzero code is returned, the operation did not succeed and the values
<span id="L94" class="LineNr"> 94 </span>of dir_name and entry_name are left unchanged.
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>Syntax:
<span id="L98" class="LineNr"> 98 </span>declare before_journal_manager_$get_bj_path_from_oid entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span>
<span id="L99" class="LineNr"> 99 </span>     aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L100" class="LineNr">100 </span>call before_journal_manager_$get_bj_path <span class="textRainbow_lv0_p0">(</span>bj_oid<span class="textRainbow_lv0_o0">,</span> dir_name<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span>
<span id="L101" class="LineNr">101 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L102" class="LineNr">102 </span>
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>Arguments:
<span id="L105" class="LineNr">105 </span>bj_oid
<span id="L106" class="LineNr">106 </span>   is the opening identifier of the before journal for which the
<span id="L107" class="LineNr">107 </span>   pathname is requested.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L108" class="LineNr">108 </span>dir_name
<span id="L109" class="LineNr">109 </span>   is the pathname of the directory in which the before journal
<span id="L110" class="LineNr">110 </span>   resides.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L111" class="LineNr">111 </span>entry_name
<span id="L112" class="LineNr">112 </span>   is the entry name of the before journal.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L113" class="LineNr">113 </span>code
<span id="L114" class="LineNr">114 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>:Entry: get_default_bj: 03/15/85 before_journal_manager_$get_default_bj
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>Function:  This entry point returns the opening identifier of the
<span id="L121" class="LineNr">121 </span>before journal to be used as the default in those cases where a before
<span id="L122" class="LineNr">122 </span>journal specification is expected but not supplied.  The rules for
<span id="L123" class="LineNr">123 </span>determining this default before journal are described in &quot;Notes&quot; under
<span id="L124" class="LineNr">124 </span>the set_default_bj entry point.  If the journal which is to serve as
<span id="L125" class="LineNr">125 </span>the default before journal is not open at the time of this call, it is
<span id="L126" class="LineNr">126 </span>opened automatically.
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>Syntax:
<span id="L130" class="LineNr">130 </span>declare before_journal_manager_$get_default_bj entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L131" class="LineNr">131 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L132" class="LineNr">132 </span>call before_journal_manager_$get_default_bj <span class="textRainbow_lv0_p0">(</span>bj_oid<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>Arguments:
<span id="L136" class="LineNr">136 </span>bj_oid
<span id="L137" class="LineNr">137 </span>   is the opening identifier of the current default before journal.
<span id="L138" class="LineNr">138 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L139" class="LineNr">139 </span>code
<span id="L140" class="LineNr">140 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L141" class="LineNr">141 </span>
<span id="L142" class="LineNr">142 </span>
<span id="L143" class="LineNr">143 </span>:Entry:  open_bj:  03/15/85 before_journal_manager_$open_bj
<span id="L144" class="LineNr">144 </span>
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>Function:  This entry point makes the before journal specified by the
<span id="L147" class="LineNr">147 </span>pathname, ready for use by any transaction of the current process.  A
<span id="L148" class="LineNr">148 </span>process may have several before journals open at the same time, and may
<span id="L149" class="LineNr">149 </span>also have the same journal opened more than one time.  When a
<span id="L150" class="LineNr">150 </span>transaction is started, one of the open journals must be associated
<span id="L151" class="LineNr">151 </span>with the transaction, if the transaction needs a before journal.  One
<span id="L152" class="LineNr">152 </span>can expect that in most cases, a process will open only one before
<span id="L153" class="LineNr">153 </span>journal, which will be used by all its transactions.
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>This entry may also change the default before journal for the process
<span id="L156" class="LineNr">156 </span>to the newly opened journal <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; under set_default_bj<span class="textRainbow_lv0_p0">)</span>.
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>
<span id="L159" class="LineNr">159 </span>Syntax:
<span id="L160" class="LineNr">160 </span>declare before_journal_manager_$open_bj entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L161" class="LineNr">161 </span>     bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L162" class="LineNr">162 </span>call before_journal_manager_$open_bj <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span>
<span id="L163" class="LineNr">163 </span>     bj_opening_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L164" class="LineNr">164 </span>
<span id="L165" class="LineNr">165 </span>
<span id="L166" class="LineNr">166 </span>Arguments:
<span id="L167" class="LineNr">167 </span>dir_name
<span id="L168" class="LineNr">168 </span>   is the pathname of the directory in which the before journal to be
<span id="L169" class="LineNr">169 </span>   opened resides.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L170" class="LineNr">170 </span>entry_name
<span id="L171" class="LineNr">171 </span>   is the entry name of the before journal to be opened.  The .bj
<span id="L172" class="LineNr">172 </span>   suffix must be included <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L173" class="LineNr">173 </span>bj_opening_id
<span id="L174" class="LineNr">174 </span>   is the opening identifier of the journal.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> This specifier
<span id="L175" class="LineNr">175 </span>   must be used subsequently by the current process to identify this
<span id="L176" class="LineNr">176 </span>   journal.
<span id="L177" class="LineNr">177 </span>code
<span id="L178" class="LineNr">178 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>
<span id="L181" class="LineNr">181 </span>Notes:  When a before journal is opened, it is remembered in a per
<span id="L182" class="LineNr">182 </span>system table containing the pathnames and unique identifiers of all
<span id="L183" class="LineNr">183 </span>before journals opened in the system.  This table is used after a
<span id="L184" class="LineNr">184 </span>system crash to determine which journals must be reopened and examined
<span id="L185" class="LineNr">185 </span>in order to perform a rollback operation.  To preserve the integrity of
<span id="L186" class="LineNr">186 </span>this table, it is written out to disk automatically each time it is
<span id="L187" class="LineNr">187 </span>updated with a newly opened journal.
<span id="L188" class="LineNr">188 </span>
<span id="L189" class="LineNr">189 </span>If a process opens the same before journal more than one time, the
<span id="L190" class="LineNr">190 </span>opening identifier received from the open_bj will be the same for each
<span id="L191" class="LineNr">191 </span>call.  The process must close a before journal the same number of times
<span id="L192" class="LineNr">192 </span>it opens it, to render the journal inaccessible through the same
<span id="L193" class="LineNr">193 </span>opening identifier.
<span id="L194" class="LineNr">194 </span>
<span id="L195" class="LineNr">195 </span>
<span id="L196" class="LineNr">196 </span>:Entry:  set_default_bj:  03/15/85 before_journal_manager_$set_default_bj
<span id="L197" class="LineNr">197 </span>
<span id="L198" class="LineNr">198 </span>
<span id="L199" class="LineNr">199 </span>Function:  This entry point causes the specified before journal to
<span id="L200" class="LineNr">200 </span>become the default before journal.  When no before journal is
<span id="L201" class="LineNr">201 </span>explicitly specified by the user at the beginning of a transaction, the
<span id="L202" class="LineNr">202 </span>default before journal for the process will be assigned to the
<span id="L203" class="LineNr">203 </span>transaction.  The default before journal must be one of the before
<span id="L204" class="LineNr">204 </span>journals open in the process.
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>
<span id="L207" class="LineNr">207 </span>Syntax:
<span id="L208" class="LineNr">208 </span>declare before_journal_manager_$set_default_bj entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L209" class="LineNr">209 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L210" class="LineNr">210 </span>call before_journal_manager_$set_default_bj <span class="textRainbow_lv0_p0">(</span>bj_opening_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L211" class="LineNr">211 </span>
<span id="L212" class="LineNr">212 </span>
<span id="L213" class="LineNr">213 </span>Arguments:
<span id="L214" class="LineNr">214 </span>bj_opening_id
<span id="L215" class="LineNr">215 </span>   is the opening identifier of the before journal.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L216" class="LineNr">216 </span>code
<span id="L217" class="LineNr">217 </span>   is a standard system error code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L218" class="LineNr">218 </span>
<span id="L219" class="LineNr">219 </span>
<span id="L220" class="LineNr">220 </span>Notes:  Several before_journal_manager_ entries expect an opening id to
<span id="L221" class="LineNr">221 </span>specify which before journal to use.  If bj_opening_id is null, the
<span id="L222" class="LineNr">222 </span>following default assignments are attempted, in the order in which they
<span id="L223" class="LineNr">223 </span>are mentioned below, until one of them succeeds:
<span id="L224" class="LineNr">224 </span>
<span id="L225" class="LineNr">225 </span>The current default before journal in this process, if there is
<span id="L226" class="LineNr">226 </span>one; otherwise,
<span id="L227" class="LineNr">227 </span>
<span id="L228" class="LineNr">228 </span>The most recently open before journal among those that are still
<span id="L229" class="LineNr">229 </span>open, if there is one; otherwise,
<span id="L230" class="LineNr">230 </span>
<span id="L231" class="LineNr">231 </span>The system before journal.  If the system before journal has not
<span id="L232" class="LineNr">232 </span>been opened yet in the current process, it is automatically
<span id="L233" class="LineNr">233 </span>opened.
<span id="L234" class="LineNr">234 </span>
<span id="L235" class="LineNr">235 </span>
<span id="L236" class="LineNr">236 </span>:Entry: set_transaction_storage_limit: 03/15/85 before_journal_manager_$set_transaction_storage_limit
<span id="L237" class="LineNr">237 </span>
<span id="L238" class="LineNr">238 </span>
<span id="L239" class="LineNr">239 </span>Syntax:
<span id="L240" class="LineNr">240 </span>declare before_journal_manager_$set_transaction_storage_limit entry
<span id="L241" class="LineNr">241 </span>    <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L242" class="LineNr">242 </span>call before_journal_manager_$set_transaction_storage_limit <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span>
<span id="L243" class="LineNr">243 </span>     entryname<span class="textRainbow_lv0_o0">,</span> storage_limit<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L244" class="LineNr">244 </span>
<span id="L245" class="LineNr">245 </span>
<span id="L246" class="LineNr">246 </span>Arguments:
<span id="L247" class="LineNr">247 </span>dir_name
<span id="L248" class="LineNr">248 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L249" class="LineNr">249 </span>entryname
<span id="L250" class="LineNr">250 </span>   is the entryname of the before journal.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L251" class="LineNr">251 </span>storage_limit
<span id="L252" class="LineNr">252 </span>   is the maximum number of bytes a single transaction may use in the
<span id="L253" class="LineNr">253 </span>   before journal.
<span id="L254" class="LineNr">254 </span>code
<span id="L255" class="LineNr">255 </span>   is a storage system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
